/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ConnectorsGoogleAnalytics4ApiService ConnectorsGoogleAnalytics4Api service
type ConnectorsGoogleAnalytics4ApiService service

type ApiGoogleAnalytics4ControllerActionAccountRequest struct {
	ctx                                                      context.Context
	ApiService                                               *ConnectorsGoogleAnalytics4ApiService
	appConnectorNetsuiteNetsuiteConnectorActionObjectRequest *AppConnectorNetsuiteNetsuiteConnectorActionObjectRequest
}

func (r ApiGoogleAnalytics4ControllerActionAccountRequest) AppConnectorNetsuiteNetsuiteConnectorActionObjectRequest(appConnectorNetsuiteNetsuiteConnectorActionObjectRequest AppConnectorNetsuiteNetsuiteConnectorActionObjectRequest) ApiGoogleAnalytics4ControllerActionAccountRequest {
	r.appConnectorNetsuiteNetsuiteConnectorActionObjectRequest = &appConnectorNetsuiteNetsuiteConnectorActionObjectRequest
	return r
}

func (r ApiGoogleAnalytics4ControllerActionAccountRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.GoogleAnalytics4ControllerActionAccountExecute(r)
}

/*
GoogleAnalytics4ControllerActionAccount List of accounts

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGoogleAnalytics4ControllerActionAccountRequest
*/
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionAccount(ctx context.Context) ApiGoogleAnalytics4ControllerActionAccountRequest {
	return ApiGoogleAnalytics4ControllerActionAccountRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionAccountExecute(r ApiGoogleAnalytics4ControllerActionAccountRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsGoogleAnalytics4ApiService.GoogleAnalytics4ControllerActionAccount")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/google_analytics4/actions/account"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appConnectorNetsuiteNetsuiteConnectorActionObjectRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGoogleAnalytics4ControllerActionAuthorizationRequest struct {
	ctx        context.Context
	ApiService *ConnectorsGoogleAnalytics4ApiService
}

func (r ApiGoogleAnalytics4ControllerActionAuthorizationRequest) Execute() ([]ActionAuthorizationResponseInner, *http.Response, error) {
	return r.ApiService.GoogleAnalytics4ControllerActionAuthorizationExecute(r)
}

/*
GoogleAnalytics4ControllerActionAuthorization List of authorization objects

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGoogleAnalytics4ControllerActionAuthorizationRequest
*/
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionAuthorization(ctx context.Context) ApiGoogleAnalytics4ControllerActionAuthorizationRequest {
	return ApiGoogleAnalytics4ControllerActionAuthorizationRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []ActionAuthorizationResponseInner
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionAuthorizationExecute(r ApiGoogleAnalytics4ControllerActionAuthorizationRequest) ([]ActionAuthorizationResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodGet
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []ActionAuthorizationResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsGoogleAnalytics4ApiService.GoogleAnalytics4ControllerActionAuthorization")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/google_analytics4/actions/authorization"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGoogleAnalytics4ControllerActionDimensionRequest struct {
	ctx                                              context.Context
	ApiService                                       *ConnectorsGoogleAnalytics4ApiService
	googleAnalytics4ControllerActionDimensionRequest *GoogleAnalytics4ControllerActionDimensionRequest
}

func (r ApiGoogleAnalytics4ControllerActionDimensionRequest) GoogleAnalytics4ControllerActionDimensionRequest(googleAnalytics4ControllerActionDimensionRequest GoogleAnalytics4ControllerActionDimensionRequest) ApiGoogleAnalytics4ControllerActionDimensionRequest {
	r.googleAnalytics4ControllerActionDimensionRequest = &googleAnalytics4ControllerActionDimensionRequest
	return r
}

func (r ApiGoogleAnalytics4ControllerActionDimensionRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.GoogleAnalytics4ControllerActionDimensionExecute(r)
}

/*
GoogleAnalytics4ControllerActionDimension Get Google Analytics dimensions

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGoogleAnalytics4ControllerActionDimensionRequest
*/
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionDimension(ctx context.Context) ApiGoogleAnalytics4ControllerActionDimensionRequest {
	return ApiGoogleAnalytics4ControllerActionDimensionRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionDimensionExecute(r ApiGoogleAnalytics4ControllerActionDimensionRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsGoogleAnalytics4ApiService.GoogleAnalytics4ControllerActionDimension")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/google_analytics4/actions/dimension"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.googleAnalytics4ControllerActionDimensionRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGoogleAnalytics4ControllerActionLoadRequest struct {
	ctx                           context.Context
	ApiService                    *ConnectorsGoogleAnalytics4ApiService
	googleAnalytics4ConnectorForm *GoogleAnalytics4ConnectorForm
}

func (r ApiGoogleAnalytics4ControllerActionLoadRequest) GoogleAnalytics4ConnectorForm(googleAnalytics4ConnectorForm GoogleAnalytics4ConnectorForm) ApiGoogleAnalytics4ControllerActionLoadRequest {
	r.googleAnalytics4ConnectorForm = &googleAnalytics4ConnectorForm
	return r
}

func (r ApiGoogleAnalytics4ControllerActionLoadRequest) Execute() (*Source, *http.Response, error) {
	return r.ApiService.GoogleAnalytics4ControllerActionLoadExecute(r)
}

/*
GoogleAnalytics4ControllerActionLoad Create Google Analytics 4 source

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGoogleAnalytics4ControllerActionLoadRequest
*/
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionLoad(ctx context.Context) ApiGoogleAnalytics4ControllerActionLoadRequest {
	return ApiGoogleAnalytics4ControllerActionLoadRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return Source
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionLoadExecute(r ApiGoogleAnalytics4ControllerActionLoadRequest) (*Source, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *Source
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsGoogleAnalytics4ApiService.GoogleAnalytics4ControllerActionLoad")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/google_analytics4/create-source"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.googleAnalytics4ConnectorForm
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGoogleAnalytics4ControllerActionMetricRequest struct {
	ctx         context.Context
	ApiService  *ConnectorsGoogleAnalytics4ApiService
	requestBody *map[string]GoogleAnalytics4ControllerActionMetricRequestValue
}

func (r ApiGoogleAnalytics4ControllerActionMetricRequest) RequestBody(requestBody map[string]GoogleAnalytics4ControllerActionMetricRequestValue) ApiGoogleAnalytics4ControllerActionMetricRequest {
	r.requestBody = &requestBody
	return r
}

func (r ApiGoogleAnalytics4ControllerActionMetricRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.GoogleAnalytics4ControllerActionMetricExecute(r)
}

/*
GoogleAnalytics4ControllerActionMetric List of metrics

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGoogleAnalytics4ControllerActionMetricRequest
*/
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionMetric(ctx context.Context) ApiGoogleAnalytics4ControllerActionMetricRequest {
	return ApiGoogleAnalytics4ControllerActionMetricRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionMetricExecute(r ApiGoogleAnalytics4ControllerActionMetricRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsGoogleAnalytics4ApiService.GoogleAnalytics4ControllerActionMetric")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/google_analytics4/actions/metric"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.requestBody
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGoogleAnalytics4ControllerActionPreviewRequest struct {
	ctx                           context.Context
	ApiService                    *ConnectorsGoogleAnalytics4ApiService
	googleAnalytics4ConnectorForm *GoogleAnalytics4ConnectorForm
}

func (r ApiGoogleAnalytics4ControllerActionPreviewRequest) GoogleAnalytics4ConnectorForm(googleAnalytics4ConnectorForm GoogleAnalytics4ConnectorForm) ApiGoogleAnalytics4ControllerActionPreviewRequest {
	r.googleAnalytics4ConnectorForm = &googleAnalytics4ConnectorForm
	return r
}

func (r ApiGoogleAnalytics4ControllerActionPreviewRequest) Execute() (*SuccessResponse, *http.Response, error) {
	return r.ApiService.GoogleAnalytics4ControllerActionPreviewExecute(r)
}

/*
GoogleAnalytics4ControllerActionPreview Preview the data

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGoogleAnalytics4ControllerActionPreviewRequest
*/
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionPreview(ctx context.Context) ApiGoogleAnalytics4ControllerActionPreviewRequest {
	return ApiGoogleAnalytics4ControllerActionPreviewRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return SuccessResponse
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionPreviewExecute(r ApiGoogleAnalytics4ControllerActionPreviewRequest) (*SuccessResponse, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *SuccessResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsGoogleAnalytics4ApiService.GoogleAnalytics4ControllerActionPreview")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/google_analytics4/preview"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.googleAnalytics4ConnectorForm
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGoogleAnalytics4ControllerActionPropertyRequest struct {
	ctx                                             context.Context
	ApiService                                      *ConnectorsGoogleAnalytics4ApiService
	googleAnalytics4ControllerActionPropertyRequest *GoogleAnalytics4ControllerActionPropertyRequest
}

func (r ApiGoogleAnalytics4ControllerActionPropertyRequest) GoogleAnalytics4ControllerActionPropertyRequest(googleAnalytics4ControllerActionPropertyRequest GoogleAnalytics4ControllerActionPropertyRequest) ApiGoogleAnalytics4ControllerActionPropertyRequest {
	r.googleAnalytics4ControllerActionPropertyRequest = &googleAnalytics4ControllerActionPropertyRequest
	return r
}

func (r ApiGoogleAnalytics4ControllerActionPropertyRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.GoogleAnalytics4ControllerActionPropertyExecute(r)
}

/*
GoogleAnalytics4ControllerActionProperty List of properties

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGoogleAnalytics4ControllerActionPropertyRequest
*/
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionProperty(ctx context.Context) ApiGoogleAnalytics4ControllerActionPropertyRequest {
	return ApiGoogleAnalytics4ControllerActionPropertyRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *ConnectorsGoogleAnalytics4ApiService) GoogleAnalytics4ControllerActionPropertyExecute(r ApiGoogleAnalytics4ControllerActionPropertyRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ConnectorsGoogleAnalytics4ApiService.GoogleAnalytics4ControllerActionProperty")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/connectors/google_analytics4/actions/property"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.googleAnalytics4ControllerActionPropertyRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
